#include "ZRGame.h"
#include "ZR_API.h"
#include "ZRUser.hpp"
#include <math.h>

static ZeroRoboticsGame &game = ZeroRoboticsGame::instance();
static ZeroRoboticsAPI &api = ZeroRoboticsAPI::instance();

//Implement your simulation code in init() and loop()
class ZRUser1029 : public ZRUser
{

//Begin page main
#define DARK -1
#define LIGHT 1

//Rare that these should be here
bool otherHasMirror;
bool dive;
bool uploading;
float speedLimit;
float velocity;
float myEnergy;
float bestDistance;     //the distance between the closest item and you 
float distanceBetweenUs;//the distance between you and the other SPHERE
int memory;
int getNumMirrorsHeld;
int getMirrorTimeRemaining;
int bestID;  
int zone;
int otherZone;
int action;
int data; int mirror; int otherMirror; int freeData;
int counter;            // time variable
float attitude[3];      //the official setter for your desired attitude (where you're facing)
float position[3];      //the official setter for your desired position
int itemStatis[9];      // put it right here
float myState[12];      //all information about your SPHERE
float otherState[12];   //all information about opponent SPHERE
float items[9][3];      //contains the position for all 9 items
float fuel;

void init(){
	action = 1;
    dive = false;
	//origin[0] = origin[1] = origin[2] = 0.0f;
	DEBUG(("Greetings from Cookie Source Invaders."));
	DEBUG(("Please ignore the extravegent assortment of comments to come..."));
} //end of init

void loop(){
	// Updates
	float temp[3];          //literally a temp array, used for calculations 
    api.getMyZRState(myState);
	api.getOtherZRState(otherState);
	data = mirror = otherMirror = freeData = 0;
	for (int a = 0; a < 9; a++){
	    game.getItemLoc(items[a], a);//Item location to items[] array
	    itemStatis[a] = game.hasItem(a);
	    if (a >= 3 && a <= 6){
            if (itemStatis[a] == 0) data++;//If we have these items, add to amount of score packs we have
            if (itemStatis[a] == -1) freeData++;
	    }
	    if (a >= 7){
            if (itemStatis[a] == 0) mirror++;//If we have a mirror
            if (itemStatis[a] == 1) otherMirror++;//If the other people have a mirror
	    }
    }// end of for loop
    
	zone = game.posInArea(myState);
	otherZone = game.posInArea(otherState);
	myEnergy = game.getEnergy();
	getMirrorTimeRemaining = game.getMirrorTimeRemaining();
	velocity = mathVecMagnitude(&myState[3], 3);
	counter= game.getCurrentTime();
	memory = game.getMemoryFilled();
	speedLimit = 0.5f;
	getNumMirrorsHeld = game.getNumMirrorsHeld();
	fuel = game.getFuelRemaining();

	DEBUG(("zone=%d otherZone=%d myEnergy=%f MirTimeRemaining=%d velocity=%f counter =%d memory=%d speedLimit =%f getNumMirrorsHeld=%d fuel=%f",
	zone,
	otherZone,
	myEnergy,
	getMirrorTimeRemaining,
	velocity,
	counter,
	memory,
  speedLimit,
  getNumMirrorsHeld,
  fuel
	));
	
	if (memory == 0) uploading = false;
	
	takePictures(); //function description below. 
	upload();       //function description below.
	
	// Decision Making
	// ALL YOUR CODE GOES HERE!!! WRITE EVERYTHING HERE!!! 
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    memcpy(position, myState, sizeof(float)*3);
    switch (action){
        case 1:
        
            DEBUG(("Case 1"));
            grabClosestItems(3,6,true); 
            DEBUG(("Grabbing data"));
           
            if (    data > 0 && (
                    (data == 1 && items[bestID][2] > 0.0f && bestDistance > 0.2f) || 
                    zone != -1 ||
                    data >= 2)
                    )
            {
                action = 2;
            }
            // editted 12/19
            else { 
                break;
            }
          
        case 2:
            DEBUG(("Case 2"));
            grabClosestItems(7,8,true);
           
            if ( bestID != -1 && bestDistance > distance(temp,items[bestID],otherState) && otherMirror == 0 ){
                if ( bestID == 7) bestID = 8; else bestID = 7;//grab closest mirror
                if (itemStatis[bestID] == -1) {
                    memcpy(position,items[bestID],sizeof(float)*3) ;
                } else 
                    bestID = -1; 
            }
            
            DEBUG(("Grabbing mirrors"));
            /*If we have a mirror or bestID is not good*/
            if (mirror == 1 || bestID == -1 ){
                action = 3;
            }
            //editted 12/19
            else {
                break;
            }
            
         case 3:
            DEBUG(("Case 3"));
            
            if ( zone != DARK && ! (getMirrorTimeRemaining > 18 && dive) )  {
                if (myState[1] > -0.45f) {
                     position[1] -= 0.35f;
                }
            } 
            else {
                if ( freeData > 0 && mirror > 0 ) dive=true ; else dive = false;
                if (dive) { 
                    grabClosestItems(3,6,true);
                    DEBUG(("Grabbing data"));
                    dive = true;
                    speedLimit = 0.35f;
                } 
                else { 
                    if (zone == DARK) { 
                        DEBUG(("Running away from light")); 
                        if (myState[2] > -0.33f) position[2] -= 0.2f ;else position[2] = -0.53f;
                        if (myState[1] < 0.45f) position[1] += 0.22f; else position[1] = 0.65f;    
                    }
                }
            }
	        break;
    } //end of switch statements
	
	if(action > 2 && getMirrorTimeRemaining == 0){
    	grabClosestItems(3,6, false);
    	DEBUG(("BEST DISTANCE: %f . Best ID: %d", bestDistance, bestID));
    	if (bestDistance < 0.2f && velocity < 0.15f) {
    	    grabClosestItems(3,6, true);
    	    DEBUG(("DETOUR"));
    	}
	}
	
	mathVecSubtract(temp, myState, otherState, 3);
	mathVecNormalize(temp, 3);
	float pseudoAngle = distance(temp, temp, &otherState[6]);
	
 	memcpy(temp, myState, sizeof(float)*3); 
 	temp[1] -= 0.075f; 
	
	if (getNumMirrorsHeld > 0 && 
	    pseudoAngle < 0.55f &&
	    (game.getOtherEnergy() > 0.5f || otherZone == LIGHT) &&
	    distanceBetweenUs > 0.45f && 
	    !(otherZone != DARK && otherState[2] - myState[2] > 0.5f) && 
	    (game.posInDark(temp) == false || zone != DARK) && 
	    counter > 90
	    ){
	        game.useMirror();
	    }

    if (otherHasMirror == false && 
        ((myEnergy < 1.0f && zone == -1) || (counter > 170 && memory ==0 ) || 
        (counter > 150 && myState[1] > 0.5f && memory == 0 && freeData == 0))){
        game.takePic();
    }
	
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
	// Always Do
	goTo();
	api.setAttitudeTarget(attitude);
} //end of loop

void goTo(){
    float vTgt[3];
    float scaledTgt[3];
    float dToTgt ;

    if (
        fuel < 5 || 
        (myEnergy < 1.0f && zone != 1) || 
        (distanceBetweenUs < 0.3f && velocity > 0.025f)
        ) {
        memcpy(position, myState, sizeof(float)*3); 
    }
    //x and z = .55 y = 0.7
    else if (myState[0] < -0.55f || myState[0] > 0.55f || myState[1] < -0.7f || myState[1] > 0.7f || myState[2] < -0.55f || myState[2] > 0.55f) {
        position[0]=position[1]=position[2]=0.0f;
    }

    dToTgt = distance(vTgt, position, myState);
    if ( dToTgt < speedLimit) speedLimit = dToTgt ;
    if ( dToTgt > 0 ) mathVecNormalize(vTgt, 3);
    for (int i=0; i<3; i++)  vTgt[i] *= speedLimit ;  
    mathVecAdd(scaledTgt, vTgt, myState, 3);
    api.setPositionTarget(scaledTgt);
}

//takePictures: always sets your attitude to face opponent. Note: overidden by functions called below in loop (i.e. upload) 
//takePictures: takes pictures under the neccessary condition. 
void takePictures(){
    otherHasMirror = false;
    distanceBetweenUs = distance(attitude, otherState, myState);
    mathVecNormalize(attitude, 3);
    
    if (uploading == false &&
        distanceBetweenUs > 0.5f && //there is enough distance 
        otherZone != DARK && //they are not in the dark
        game.isFacingOther() == true && //I am facing them
        memory != 2 && //my memory is not full
        game.isCameraOn() == true && //my Camera is On
        ((zone == 1 && myEnergy > 1.0f ) || (zone != 1 && myEnergy > 2.1f)) && 
        getMirrorTimeRemaining == 0  && //I do not have a mirror deployed
        // (memory > 0 && counter < 30) == false && 
        action != 1
        ){
        //if they have never picked up an item
        if (otherMirror > 0) {
            // If they have a mirror deployed
            if (game.getPicPoints() < 0.0f){ 
                otherHasMirror = true;
            } 
        }
        //If not deployed, take picture. 
        if (otherHasMirror == false){
            game.takePic();
        }
    } // first set of requirements
} //end of takePictures

//upload: faces earth and uploads pictures if memory is full or if games is about to end. 
void upload(){
    if (memory == 2 || 
        (memory > 0 && counter > 140) ||
        ((otherHasMirror || getMirrorTimeRemaining > 1) && zone == 1 && memory > 0) || 
        (otherZone == DARK && myEnergy > 2.5f && memory > 0)
        ){ 
        attitude[0] = attitude[1] = 0.0f; attitude[2] = 1.0f;
        uploading = true;
        if (
            myState[8] > 0.968f && 
            mathVecMagnitude(&myState[9], 3) < 0.05f &&
            (((zone == 1 && myEnergy > 1.0f ) || (zone != 1 && myEnergy > 2.0f)) || (myEnergy > 1.0f && counter > 145) )
            ){
            game.uploadPics();
        } // if I am facing earth, upload
    } //if my memory is full or the game is about to end and I have pic
} //end of upload


//safety: conditions are listed within function. 
// NO LONGER CALLED
/*
void safety(){
    // if my fuel is low, energy is low, or I am going to fast, stop my motion

    if (
        game.getFuelRemaining() < 5 || 
        myEnergy < 1.0f  || 
        (distanceBetweenUs < 0.3f && velocity > 0.025f)
        ) {
        memcpy(position, myState, sizeof(float)*3); 
    }
    // if my fuel is lower or  my energy is lower, stop attitude
    
    if (game.getFuelRemaining() < 2.5f || myEnergy < 0.5f){
        memcpy(attitude, &myState[6], sizeof(float)*3); 
    }
    
    // if I am out of bounds or nearing out of bounds, then move towards the origin
    // origin is arbitrary but works :)
    if (myState[0] < -0.57f || myState[0] > 0.61f || myState[1] < -0.76f || myState[1] > 0.76f || myState[2] < -0.60f || myState[2] > 0.60f) {
        position[0]=position[1]=position[2]=0.0f;
        //mathVecSubtract(position, origin, origin, 3);    
    }
}
*/
//end of safety

//grabClosestItems: grabs items closest to you based on their ID (argument of function)
void grabClosestItems(int start, int end, bool set){
/*
	energy: start = 0, end = 2.
	data: start = 3, end = 6.
	energy & data: start = 0, end = 6.
	mirror: start = 7, end = 8.
	if set is true, then actually move to grab the items. 
	if set is false, just calculate the closest one. 
*/
	float temp[3];
	bestDistance = 100.0f; bestID = -1;
	// The variable "float bestDistan ce = 100.f;" is made global for the purpose of loop()
	for (int a = start; a <= end; a ++){		
		if (itemStatis[a] == -1 ){       // if enough space, then make sure other sphere is going towards item (so include angle) before not going to it
		    float myDist = distance(temp, items[a], myState);
		    //mathVecSubtract(temp, items[a], otherState, 3);
		    //float otherDist = mathVecMagnitude(temp, 3);
		    //if (myDist < bestDistance && (myDist < otherDist || otherDist > 0.15f))  {
		    if (myDist < bestDistance) {
			    bestDistance = myDist;
			    bestID = a;
		    }
		}
	}
	
	if (data == 0 && ! (items[3][2] < 0.15f && items[5][2] < 0.15f) ){
	      if ( items[3][2] < items[5][2] ){
	         if (bestID > 4 ) bestID -=2 ;
	      } else {
	         if (bestID < 5 ) bestID +=2 ;
	      }
	}
	
	if (bestID != -1 && set){
		memcpy(position, items[bestID], sizeof(float)*3);       
	}
} //end of grabClosestItems

float distance(float store[3], float one[3], float two[3]){
    mathVecSubtract(store, one, two, 3);
    return mathVecMagnitude(store, 3); 
}
//End page main

};

ZRUser *zruser7 = new ZRUser1029;
